//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.bug;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Scrollbar;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;
import java.awt.Font;

public final class Bug4 extends Applet {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/bug/Bug4.java,v $ $revision$ $Date: 1998/11/02 15:54:45 $ Copyright 1998 INRIA.";

    public void init() {
	setLayout(new BorderLayout());
	final Label theStatus = new Label("Click on the arrows.");
	theStatus.setFont(new Font("Serif",Font.BOLD,22));
	add(BorderLayout.SOUTH,theStatus);
	final Label theText = new Label("Initial value : " + _value + 
					". Increment : " + INCREMENT + ".");
	add(BorderLayout.NORTH,theText);
	final Scrollbar theScrollbar = new Scrollbar(Scrollbar.HORIZONTAL,0, 64, 0, 255);
	theScrollbar.setBlockIncrement(10);
	theScrollbar.setUnitIncrement(10);
	add(BorderLayout.CENTER,theScrollbar);
	theScrollbar.addAdjustmentListener(new AdjustmentListener() {
	  public final void adjustmentValueChanged(AdjustmentEvent anEvent) {
	      if ( ( anEvent.getAdjustmentType() == AdjustmentEvent.UNIT_INCREMENT ) &&
		   ( (_value + INCREMENT) != anEvent.getValue() ) ) {
		  theStatus.setText("ERROR : expected value = " + (_value + INCREMENT));
		  theStatus.invalidate();
	      }
	      else {
		  if ( ( anEvent.getAdjustmentType() == AdjustmentEvent.UNIT_DECREMENT ) &&
		       ( (_value - INCREMENT) != anEvent.getValue() ) ) {
		      theStatus.setText("ERROR : expected value = " + (_value - INCREMENT));
		      theStatus.invalidate();
		  }
		  else {
		      theStatus.setText("Click on the arrows.");
		      theStatus.invalidate();
		  }
	      }
	      theText.setText("Old value : " + _value + 
			      ". New Value : " + anEvent.getValue() + 
			      ". Increment : " + INCREMENT + ".");
 	      _value = anEvent.getValue();
	      theText.invalidate();
	      validate();
	  }
	}); 
	validate();
    }

    private final static int INCREMENT = 10;
    int _value = 0;

}
