//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.event;

import figue.box.GlyphInterface;
import figue.InteractiveFacade;
import figue.path.PathInterface;
import figue.path.LinearPath;

import java.awt.event.MouseEvent;

/**
 * [PENDING: update the comments] DefaultMouseMotionListener.
 */

public class DefaultMouseMotionListener extends DefaultListener implements PointingMotionListenerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/event/DefaultMouseMotionListener.java,v $ $revision$ $Date: 1998/11/02 15:54:54 $ Copyright 1998 INRIA.";
  
    public DefaultMouseMotionListener(InteractiveFacade aFacade) {
	super(aFacade);
	_previousDragSelection = null;
	_draggingFlag = false;
    }

    public void moving(PointingEvent anEvent) {
    }

    public void startDragging(PointingEvent anEvent) {
	_draggingFlag = true;
	_previousDragSelection = anEvent.getGlyph();
	final PathInterface thePath = anEvent.getPath();
	if ( thePath != null ) {
	    PathInterface theExtendedPath = new LinearPath();
	    theExtendedPath.addChild(thePath);
	    if ( anEvent.getAwtEvent().isShiftDown() ) {
		modifyCurrentSelection(theExtendedPath);
	    }
	    else {
		setCurrentSelection(theExtendedPath);
	    }
	}
    }

    public void dragging(PointingEvent anEvent) {
	final MouseEvent theLowLevelEvent = anEvent.getAwtEvent();
	if ( _draggingFlag ) {
	    if ( anEvent.getGlyph()  != _previousDragSelection ) {
		_previousDragSelection = anEvent.getGlyph();
		final PathInterface thePath = anEvent.getPath();
		if ( thePath != null ) {
		    PathInterface theExtendedPath = new LinearPath();
		    theExtendedPath.addChild(anEvent.getPath());
		    if ( theLowLevelEvent.isShiftDown() ) {
			modifyCurrentSelection(theExtendedPath);
		    }
		    else {
			setCurrentSelection(theExtendedPath);
		    }
		}
	    }
	}
    }

    public void stopDragging(PointingEvent anEvent) {
	_draggingFlag = false;
	_previousDragSelection = null;
    }

    private GlyphInterface _previousDragSelection;
    private boolean _draggingFlag;

}

