//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

public abstract class Action implements ActionInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/Action.java,v $ $revision$ $Date: 1998/11/02 15:54:57 $ Copyright 1998 INRIA.";

    protected Action(String aName,
		     boolean aBetterThanNoneFlag,
		     boolean aBetterThanShrinkFlag,
		     boolean aBetterThanShrinkSonFlag,
		     boolean aBetterThanNewLineFlag) {
	_name = aName;
	_betterThanNone = aBetterThanNoneFlag;
	_betterThanShrink = aBetterThanShrinkFlag;
	_betterThanShrinkSon = aBetterThanShrinkSonFlag;
	_betterThanNewLine = aBetterThanNewLineFlag;
    }

    public final boolean isBetterThanNone(ActionNone anActionNone) {
	return _betterThanNone;
    }
  
    public final boolean isBetterThanShrink(ActionShrink anActionShrink) {
	return _betterThanShrink;
    }

    public final boolean isBetterThanShrinkSon(ActionShrinkSon anActionShrinkSon) {
	return _betterThanShrinkSon;
    }

    public boolean isBetterThanNewLine(ActionNewLine anActionNewLine) {
	return _betterThanNewLine;
    }

    public String toString() {
	StringBuffer theResult = new StringBuffer("Action<");
	theResult.append(_name).append(">");
	return theResult.toString();
    }

    private String _name;
    private boolean _betterThanNone;
    private boolean _betterThanShrink;
    private boolean _betterThanShrinkSon;
    private boolean _betterThanNewLine;
  
}

