//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.geometry.Dimension;
import figue.geometry.Size;
import figue.error.ImplementationError;

public abstract class FormatStatus implements FormatStatusInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/FormatStatus.java,v $ $revision$ $Date: 1998/11/02 15:55:01 $ Copyright 1998 INRIA.";

    protected FormatStatus() {
    }

    public boolean isClean() {
	return false;
    }
  
    public boolean isProceed() {
	return false;
    }
  
    public boolean isDirty() {
	return false;
    }

    public boolean isUnstable() {
	return false;
    }

    public boolean isNew() {
	return false;
    }

    public Size getCurrentSize() {
	throw new ImplementationError(toString() + ": Can't get current size");
    }
  
    public boolean setCurrentSizeAndCheckAwake(Size aSize) {
	throw new ImplementationError(toString() + ": Can't set current size");
    }

    public boolean improveEstimatedHeightAndCheckAwake(int anHeight) {
	throw new ImplementationError(toString() + ": Can't improve estimated height");
    }

    public void setEstimatedSize(Dimension aSize) {
	throw new ImplementationError(toString() + ": Can't set estimated size");
    }

    public Dimension expandEstimatedSize(int aWidth, int aHeight) { 
	throw new ImplementationError(toString() + ": Can't expand estimated size");
    }

}
