//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.box.GlyphInterface;
import figue.geometry.Dimension;
import figue.error.ShouldNotBeCalledError;

public final class FormatStatusUnstable extends FormatStatus {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/FormatStatusUnstable.java,v $ $revision$ $Date: 1998/11/02 15:55:02 $ Copyright 1998 INRIA.";

    private FormatStatusUnstable() {
	super();
    }
  
    public boolean isUnstable() {
	return true;
    }

    public final Dimension getEstimatedSize(GlyphInterface aGlyph) {
	throw new ShouldNotBeCalledError();
    }

    public final String toString() {
	return "Status<Unstable>";
    }

    public final static FormatStatusUnstable INSTANCE = new FormatStatusUnstable();
  
}
