//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.format;

import figue.internal.ContextInterface;
import figue.box.GlyphInterface;

public abstract class StrategyReadyToFormat {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategyReadyToFormat.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
  
    protected StrategyReadyToFormat() {
	;
    }
  
    public abstract void doAlgorithm(ContextInterface aContext,
				     GlyphInterface aGlyph);
  
    public final static StrategyReadyToFormat SAFE = new StrategyReadyToFormatSafe();
  
    public final static StrategyReadyToFormat UNSAFE = new StrategyReadyToFormatUnsafe();
  
}

final class StrategyReadyToFormatSafe extends StrategyReadyToFormat {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategyReadyToFormat.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
  
    public final void doAlgorithm(ContextInterface aContext,
				  GlyphInterface aGlyph) {
    }
    
}

final class StrategyReadyToFormatUnsafe extends StrategyReadyToFormat {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/format/StrategyReadyToFormat.java,v $ $revision$ $Date: 1998/11/02 15:55:07 $ Copyright 1998 INRIA.";
    
    public void doAlgorithm(ContextInterface aContext,
			    GlyphInterface aGlyph) {
	aContext.awaitStable(aGlyph);
    }
}
