//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.geometry;

/**
 * [PENDING: update the comments] Point.
 * @level advanced
 */

public final class Point {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/geometry/Point.java,v $ $revision$ $Date: 1998/11/02 15:55:09 $ Copyright 1998 INRIA.";

    public Point(int x,int y) {
	super();
	_x = x;
	_y = y;
    }
  
    public Point() { 
	this(0,0);
    }
  
    public Point(Point aPoint) {
	this(aPoint.getX(),aPoint.getY());
    }
  
    public final int getX() {
	return _x; 
    }
    public final int getY() {
	return _y; 
    }
    public final void setX(int x) { 
	_x = x; 
    }
    public final void setY(int y) { 
	_y = y; 
    }
  
    public final void setLocation(Point aPoint) {
	_x = aPoint.getX();
	_y = aPoint.getY();
    }
  
    public final void setLocation(int x, int y) {
	_x = x;
	_y = y;
    }
  
    public final void translate(Point aPoint) {
	_x += aPoint.getX();
	_y += aPoint.getY();
    }

    public final void translate(int x, int y) {
	_x += x;
	_y += y;
    }
  
    public final String toString() {
	StringBuffer theResult = new StringBuffer("Point<");
	theResult.append(getX()).append("/").append(getY()).append(">");
	return theResult.toString();
    }

    private int _x;
    private int _y;
  
}
