//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.internal;

import figue.path.PathInterface;
import figue.box.GlyphInterface;

public final class PairGlyphPath {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/internal/PairGlyphPath.java,v $ $revision$ $Date: 1998/11/02 15:55:15 $ Copyright 1998 INRIA.";

    public PairGlyphPath(GlyphInterface aGlyph) {
	_glyph = aGlyph;
	_path = null;
    }

    public final void dispose(ContextInterface aContext) {
	_glyph = null;
	_path = null;
	aContext.disposePairGlyphPath(this);
    }

    public final GlyphInterface getGlyph() {
	return _glyph;
    }

    public final void setGlyph(GlyphInterface aGlyph) {
	_glyph = aGlyph;
    }

    public final PathInterface getPath() {
	return _path;
    }

    public final void setPath(PathInterface aPath) {
	_path = aPath;
    }

    public final String toString() {
	StringBuffer theResult = new StringBuffer("PairGlyphPath<");
	theResult.append(_glyph.toString());
	if ( _path != null ) {
	    theResult.append("/").append(_path.toString());
	}
	theResult.append(">");
	return theResult.toString();
    }

    private GlyphInterface _glyph;
    private PathInterface _path;
  
}
