//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.io;

import figue.*;
import figue.box.*;
import figue.path.*;
import figue.resource.*;
import figue.selection.*;
import figue.internal.*;
import figue.FacadeInterface;

import java.io.Writer;
import java.io.IOException;
import java.io.StringReader;
import java.util.Enumeration;
import antlr.collections.AST;
import antlr.ASTFactory;
import java.util.Hashtable;

import figue.*;

/**
 * [PENDING: update the comments] Utility.
 * @level advanced
 */

public final class Utility {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/io/Utility.java,v $ $revision$ $Date: 1998/11/02 15:55:19 $ Copyright 1998 INRIA.";
 
    private Utility() {
    }

    public final static void writeStringAsXmlValue(Writer anOutput,
						   String aString) 
	throws IOException {
	final StringReader theInput = new StringReader(aString);
	int theCurrentChar = theInput.read();
	while ( theCurrentChar != -1 ) {
	    switch ( theCurrentChar ) {
	    case '<': {
		anOutput.write("&lt;");
		break;
	    }
	    case '&': {
 		anOutput.write("&amp;");
		break;
	    }
	    default: {
		anOutput.write(theCurrentChar);
		break;
	    }
	    }
	    theCurrentChar = theInput.read();
	}
	theInput.close();
    }

    public final static void writeStringAsXmlValueWithSpaces(Writer anOutput,
							     String aString) 
	throws IOException {
	final StringReader theInput = new StringReader(aString);
	int theCurrentChar = theInput.read();
	while ( theCurrentChar != -1 ) {
	    switch ( theCurrentChar ) {
	    case '<': {
		anOutput.write("&lt;");
		break;
	    }
	    case '&': {
		anOutput.write("&amp;");
		break;
	    }
	    case ' ': {
		anOutput.write("&ws;");
		break;
	    }
	    case '\r':
	    case '\n': {
		anOutput.write("&ln;");
		break;
	    }
	    case '\t': {
		anOutput.write("&tab;");
		break;
	    }
	    default: {
		anOutput.write(theCurrentChar);
		break;
	    }
	    }
	    theCurrentChar = theInput.read();
	}
	theInput.close();
    }

    public final static void writeUnitAsXml(Writer anOutput,
					    UnitInterface anUnit) throws IOException {
	if ( ! anUnit.getName().equals(UnitInterface.BLANK_TENTH.getName() ) ) {
	    anOutput.write(' ');
	    anOutput.write("Unit=\"");
	    anOutput.write(anUnit.getName());
	    anOutput.write('"');
	}
    }
    
}
