//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.io.xml;

import java.util.Hashtable;
import java.util.Enumeration;

/**
 * [PENDING: update the comments] Attributes.
 * @level advanced
 */

public final class Attributes {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/io/xml/Attributes.java,v $ $revision$ $Date: 1998/11/02 15:55:19 $ Copyright 1998 INRIA.";

    public Attributes() {
	super();
	_attributes = null;
	_redefinedAttributes = null;
    }

    public final void put(String aName, String aValue) {
	if ( _attributes == null ) {
	    _attributes = new Hashtable();
	    _attributes.put(aName,aValue);
	}
	else {
	    if ( ! _attributes.containsKey(aName) ) {
		_attributes.put(aName,aValue);
	    }
	    else {
		if ( _redefinedAttributes == null ) {
		    _redefinedAttributes = new Hashtable();
		    _redefinedAttributes.put(aName,aValue);
		}
		else {
		    if ( _redefinedAttributes.containsKey(aName) ) {
			_redefinedAttributes.put(aName,aValue);
		    }
		}
	    }
	}
    }

    public final String get(String aName) {
	return (String)(_attributes.get(aName));
    }

    public final boolean hasAttributes() {
	return ( ( _attributes!= null ) &&
		 ( ! _attributes.isEmpty() ) );
    }

    public final Enumeration getAttributeNames() {
	if ( _attributes == null ) {
	    return null;
	}
	else {
	    return _attributes.keys();
	}
    }

    public final boolean hasRedefinedAttributes() {
	return ( ( _redefinedAttributes != null ) &&
		 ( ! _redefinedAttributes.isEmpty() ) );
    }

    public final Enumeration getRedefinedAttributes() {
	if ( _redefinedAttributes == null ) {
	    return null;
	}
	else {
	    return _redefinedAttributes.keys();
	}
    }

    public final void clear() {
	_attributes = null;
	_redefinedAttributes = null;
    }

    private Hashtable _attributes;
    private Hashtable _redefinedAttributes;

}
