//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.multithread;

final class InvalidThreadState implements ThreadStateInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/multithread/InvalidThreadState.java,v $ $revision$ $Date: 1998/11/02 15:55:25 $ Copyright 1998 INRIA.";

    private InvalidThreadState() {
	;
    }
    public final boolean isDone() {
	return false;
    }
    public final boolean isInactive() throws StoppedFacadeException {
	return false;
    } 
    public final boolean isFormattable() throws StoppedFacadeException {
	return false;
    }  
    public final boolean isFormatting() throws StoppedFacadeException {
	return false;
    }  
    public final void startFormat(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }  
    public final void endFormat(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void suspendFormat(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final boolean isDrawable() throws StoppedFacadeException {
	return false;
    }
    public final boolean isDrawing() throws StoppedFacadeException {
	return false;
    }
    public final void startDraw(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void endDraw(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final boolean isUpdatingGlyph() throws StoppedFacadeException {
	return false;
    }
    public final void startUpdateGlyph(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void endUpdateGlyph(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final boolean isBuilding() throws StoppedFacadeException {
	return false;
    }
    public final boolean isBuildingPhase() throws StoppedFacadeException {
	return false;
    }
    public final void startBuild(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void endBuild(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void quit(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void init(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    public final void fatalError(NotifyingThreadStateInterface aNotifyingThreadState) {
	reportInvalidState(aNotifyingThreadState);
    }
    private final void reportInvalidState(NotifyingThreadStateInterface aNotifyingThreadState) {
	aNotifyingThreadState.reportInvalidState();
    }
    public final String toString() {
	return "InvalidState<>";
    }

    final static InvalidThreadState INSTANCE = new InvalidThreadState();

}

