//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.box.GlyphInterface;
import figue.internal.PathVisitorInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] InsertGlyph.
 */

public final class InsertGlyph implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/InsertGlyph.java,v $ $revision$ $Date: 1998/11/02 15:55:28 $ Copyright 1998 INRIA.";
  
    public InsertGlyph(GlyphInterface aGlyph, int aRank) {
	super();
	_glyph = aGlyph;
	_rank = aRank;
    }
  
    public final Object clone() { 
	return new InsertGlyph(_glyph,_rank); 
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.insertGlyph(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.insertGlyph(this,aGlyph);
    }
  
    public final GlyphInterface getGlyph() {
	return _glyph; 
    }
  
    public final int getRank() { 
	return _rank; 
    }

    public final String toString() { 
	StringBuffer theResult = new StringBuffer("InsertGlyph<");
	theResult.append(_rank).append(":").append(_glyph.toString()).append(">");
	return theResult.toString();
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<InsertGlyph Rank=\"");
	anOutput.write(Integer.toString(_rank));
	anOutput.write("\">");
	_glyph.writeState(anOutput);
	anOutput.write("</InsertGlyph>");
    }
  
    private GlyphInterface _glyph;
    private int _rank;

}
