//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.internal.PathVisitorInterface;
import figue.box.GlyphInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] MarkGlyph.
 */

public final class MarkGlyph implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/MarkGlyph.java,v $ $revision$ $Date: 1998/11/02 15:55:29 $ Copyright 1998 INRIA.";
  
    private MarkGlyph() {
	super();
    }
  
    public final void dispose() {
    }
  
    public final Object clone() { 
	return this; 
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.markGlyph(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.markGlyph(this,aGlyph);
    }
  
    public final String toString() { 
	return "MarkGlyph<>";
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<MarkGlyph/>");
    }
  
    public final static MarkGlyph INSTANCE = new MarkGlyph();
  
}
