//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.box.GlyphInterface;
import figue.internal.PathVisitorInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] MarkUnstable.
 */

public final class MarkUnstable implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/MarkUnstable.java,v $ $revision$ $Date: 1998/11/02 15:55:30 $ Copyright 1998 INRIA.";

    private MarkUnstable() {
	super();
    }

    public final Object clone() {
	return this;
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.markUnstable(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.markUnstable(this,aGlyph);
    }
  
    public final String toString() { 
	return "MarkUnstable<>"; 
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<MarkUnstable/>");
    }
  
    public final static PathOperationInterface INSTANCE = new MarkUnstable();
  
}
