//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.path;

import figue.box.GlyphInterface;
import figue.internal.PathVisitorInterface;

import java.io.Writer;
import java.io.IOException;

/**
 * [PENDING: update the comments] ReplaceGlyph.
 */

public final class ReplaceGlyph implements PathOperationInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/path/ReplaceGlyph.java,v $ $revision$ $Date: 1998/11/02 15:55:31 $ Copyright 1998 INRIA.";
  
    public ReplaceGlyph(GlyphInterface aGlyph) {
	super();
	_glyph = aGlyph; 
    }
  
    public final Object clone() { 
	return new ReplaceGlyph(_glyph); 
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph,
			     SelectionPathInterface aSelectionPath) {
	aVisitor.replaceGlyph(this,aGlyph,aSelectionPath);
    }

    public final void accept(PathVisitorInterface aVisitor,
			     GlyphInterface aGlyph) {
	aVisitor.replaceGlyph(this,aGlyph);
    }
    
    public final GlyphInterface getGlyph() { 
	return _glyph; 
    }
  
    public final String toString() { 
	StringBuffer theResult = new StringBuffer("ReplaceGlyph<");
	theResult.append(_glyph.toString()).append(">");
	return theResult.toString();
    }

    public final void writeState(Writer anOutput) throws IOException {
	anOutput.write("<ReplaceGlyph>");
	_glyph.writeState(anOutput);
	anOutput.write("</ReplaceGlyph>");
    }
    
    private GlyphInterface _glyph;

}
