//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

import figue.Constants;

/**
 * [PENDING: update the comments] FontFamily.
 */

public final class FontFamily {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/FontFamily.java,v $ $revision$ $Date: 1998/11/02 15:55:37 $ Copyright 1998 INRIA.";
  
    private FontFamily(String aName,String aFamilyName,String aSystemNameForNT) {
	_name = aName;
	_family = aFamilyName;
	_systemNameForNT = aSystemNameForNT;
    }

    private FontFamily(String aName,String aFamilyName) {
	this(aName,aFamilyName,null);
    }
  
    public final static FontFamily HELVETICA = new FontFamily("HELVETICA","SansSerif");
    public final static FontFamily TIMES_ROMAN = new FontFamily("TIMES_ROMAN","Serif");
    public final static FontFamily COURIER = new FontFamily("COURIER","Monospaced");
    public final static FontFamily DIALOG = new FontFamily("DIALOG","Dialog");
    public final static FontFamily DIALOG_INPUT = new FontFamily("DIALOG_INPUT","DialogInput");
    public final static FontFamily SYMBOL = new FontFamily("SYMBOL",Constants.FIGUE_SYMBOL_FONT);
    public final static FontFamily DEFAULT = new FontFamily("DEFAULT","Default");
  
    public final String getFamilyName() { 
	return _family; 
    }
    public final String getName() {
	return _name;
    }
    /**
     * [PENDING: update the comments] getFontSystemNameForNT
     * @level advanced
     */
    public final String getFontSystemNameForNT() {
	return _systemNameForNT;
    }

    public final String toString() {
	return getFamilyName();
    }
    /**
     * [PENDING: update the comments] valueOf
     * @level advanced
     */
    public final static FontFamily valueOf(String aName) {
	if ( aName.equalsIgnoreCase("HELVETICA") ) {
	    return HELVETICA;
	}
	else {
	    if ( aName.equalsIgnoreCase("TIMES_ROMAN") ) {
		return TIMES_ROMAN;
	    }
	    else {
		if ( aName.equalsIgnoreCase("COURIER") ) {
		    return COURIER;
		}
		else {
		    if ( aName.equalsIgnoreCase("DIALOG") ) {
			return DIALOG;
		    }
		    else {
			if ( aName.equalsIgnoreCase("DIALOG_INPUT") ) {
			    return DIALOG_INPUT;
			}
			else {
			    if ( aName.equalsIgnoreCase("SYMBOL") ) {
				return SYMBOL;
			    }
			    else {
				if ( aName.equalsIgnoreCase("DEFAULT") ) {
				    return DEFAULT;
				}
				else {
				    return null;
				}
			    }
			}
		    }
		}
	    }
	}
    }

    private String _name;
    private String _family;
    private String _systemNameForNT;

    static {
	String theSymbolFontName = "";
	try {
	    theSymbolFontName = System.getProperty(Constants.FIGUE_SYMBOL_FONT);
	}
	catch ( Throwable anException ) {
	    ;
	}
	if ( ( theSymbolFontName == null ) ||
	     ( theSymbolFontName.equals("") ) ) {
	    theSymbolFontName = "Symbol";
	}
	SYMBOL._systemNameForNT = theSymbolFontName;
    }
    
}
