//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.resource;

import figue.error.ErrorHandlerInterface;
import figue.io.ExternalizableInterface;

import java.util.Enumeration;

/**
 * [PENDING: update the comments] ResourceFactoryInterface.
 * @level advanced
 */

public interface ResourceFactoryInterface extends ExternalizableInterface, ErrorHandlerInterface {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/resource/ResourceFactoryInterface.java,v $ $revision$ $Date: 1998/11/02 15:55:40 $ Copyright 1998 INRIA.";
  
    public boolean isColorDefined(String aMnemonic);
    public ColorInterface getColor(String aMnemonic) 
	throws WrongResourceException;
    public ColorInterface doGetColor(String aMnemonic,
				     BasicColor aColor)
	throws WrongResourceException;
    public ColorInterface doGetColor(String aMnemonic,
				     int red, 
				     int green, 
				     int blue)
	throws WrongResourceException;
    public ColorInterface createColor(String aMnemonic,
				      BasicColor aColor)
	throws WrongResourceException;
    public ColorInterface createColor(String aMnemonic,
				      int red, 
				      int green, 
				      int blue)
	throws WrongResourceException;
    public Enumeration colors();
    public boolean isFontDefined(String aMnemonic);
    public FontInterface getFont(String aMnemonic) 
	throws WrongResourceException;
    public FontInterface doGetFont(String aMnemonic,
				   FontFamily aFamily,
				   FontStyle aStyle,
				   int aPointSize,
				   boolean anUnderlinedFlag)
	throws WrongResourceException;
    public FontInterface createFont(String aMnemonic,
				    FontFamily aFamily,
				    FontStyle aStyle,
				    int aPointSize,
				    boolean anUnderlinedFlag)
	throws WrongResourceException;
    public Enumeration fonts();
    public boolean isStyleDefined(String aMnemonic);
    public StyleInterface getStyle(String aMnemonic) 
	throws WrongResourceException;
    public StyleInterface doGetStyle(String aMnemonic,
				     FontInterface aFont,
				     ColorInterface aColor,
				     ColorInterface aBackground) 
	throws WrongResourceException;
  
    public ColorInterface doGetDefaultColor();
    public FontInterface doGetDefaultFont();
    public ColorInterface doGetDefaultBackground();
    public StyleInterface doGetDefaultStyle();
    public Enumeration styles();

    public PortableFontInterface doGetPortableFont(String aMnemonic,
						   String aName,
						   int aDpi,
						   double aScale) throws WrongResourceException;
    public PortableFontInterface getPortableFont(String aMnemonic) throws WrongResourceException;
    public boolean isPortableFontDefined(String aMnemonic);
     public PortableFontInterface createPortableFont(String aMnemonic,
						     String aName,
						     int aDpi,
						     double aScale)
	 throws WrongResourceException;
    public Enumeration portableFonts();
    
    public ErrorHandlerInterface newErrorHandler();
  
    public void dispose();

}
