//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.utility;

import java.awt.Dimension;
import java.awt.Canvas;
import java.awt.Color;

public final class Blank extends Canvas {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/utility/Blank.java,v $ $revision$ $Date: 1998/11/02 15:56:02 $ Copyright 1998 INRIA.";

    public Blank(int aWidth, int anHeight, Color aColor) {
	super();
	_width = aWidth;
	_height = anHeight;
	setBackground(aColor);
	show();
    }

    public Blank(int aWidth, int anHeight) {
	this(aWidth,anHeight,Color.lightGray);
    }

    public final Dimension preferredSize() {
	return minimumSize();
    }

    public final Dimension minimumSize() {
	return new Dimension(_width,_height);
    }

    public final Dimension getMinimumSize() {
	return minimumSize();
    }

    public final Dimension getPreferredSize() {
	return preferredSize();
    }
    
    private int _width;
    private int _height;

}
