//*****************************************************************************
//   Copyright (c) 1998 INRIA.
//   http://www.inria.fr/croap/aioli/modules/figue/web/credits.html#COPYRIGHT
//*****************************************************************************

package figue.utility;

import java.awt.Window;
import java.awt.Graphics;
import java.awt.Frame;
import java.applet.Applet;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.BorderLayout;

public final class SplashScreen extends Window {

    /**
     * For code identification with unix what command.
     * @level internal
     */
    public final static String VERSION_ID
	= "@(#) $Source: /net/croap/CVSROOT/figue/java/utility/SplashScreen.java,v $ $revision$ $Date: 1998/11/02 15:56:03 $ Copyright 1998 INRIA.";
    
    public SplashScreen(Applet anApplet) {
 	super(getFrame(anApplet));
	setLayout(new BorderLayout());
	_about = new AboutFigue(anApplet);
 	computeLayout();
	add(BorderLayout.CENTER,_about);
	show();
    }

    private final void computeLayout() {
	final Dimension theScreenSize = getToolkit().getScreenSize();
	final int theScreenWidth = theScreenSize.width;
	final int theScreenHeight = theScreenSize.height;
	final int theWidth = Math.min(theScreenWidth * 2 / 3,400);
	final int theHeight = Math.min(theScreenHeight * 2 /3,250);
	reshape(((theWidth + theScreenWidth) / 2) - theWidth,
		((theHeight + theScreenHeight) / 2) - theHeight,
		theWidth,theHeight);
    }

    public final void done() {
 	hide();
 	dispose();
    }
    
    public final void dispose() {
	if ( _about != null ) {
	    _about.dispose();
	    _about = null;
	}
    }

    private final static Frame getFrame(Applet anApplet) {
	Container theParent = anApplet.getParent();
	while ( theParent.getParent() != null ) {
	    theParent = theParent.getParent();
	}
	return (Frame)theParent;
    }

    private AboutFigue _about;
    
}
